#ifndef PPSSUMM_FILTGRSP
#define PPSSUMM_FILTGRSP

#include <vector>
#include <string>
#include <sstream>
#include <cstdlib>
#include "ppssumm_typedef.h"
#include "BaseInteger.h"
#include "Dal.h"

class Filtgrps : public BaseInteger<int32>
{
    public:
    Filtgrps() : BaseInteger<int32>(0) { }
    Filtgrps( const int32& s ) : BaseInteger<int32>(s) {  }
    Filtgrps( const char* s ) : BaseInteger<int32>( static_cast<int32>( strtol( s , '\0' , 10 ) ) ) {  }
    Filtgrps( const std::string& s ) :  BaseInteger<int32>( static_cast<int32>( strtol( s.c_str() , '\0' , 10 ) ) ) {  }

    Filtgrps( const Filtgrps& s ) : BaseInteger<int32>(s.get()) { }
    Filtgrps operator=(const char* s)
    {
        this->set( static_cast<int32>( strtol( s , '\0' , 10 ) ) );
        return *this;
    }
    Filtgrps operator=(const std::string& s)
    { 
        this->set( static_cast<int32>( strtol( s.c_str() , '\0' , 10 ) ) );
        return *this;
    }
    Filtgrps operator=(const Filtgrps& s)
    { 
        this->set( s.get() );
        return *this;
    }

    friend std::ostream& operator<<( std::ostream& os , const Filtgrps& s )
    {
	stringlist text;
	long t = s.get();
	if ( t & 1 ) text.push_back("rejflags");
	if ( t & 2 ) text.push_back("attGTI");
	if ( t & 4 ) text.push_back("hkGTI");

	if (text.size())
	{
	    std::stringstream ss;
	    stringlist_ci CI= text.begin();
	    ss << *CI;
	    ++CI;
	    for ( ; CI != text.end(); ++CI )
	    {
		ss << "," << *CI;
	    }
	    os << ss.str();
	}   
	else
	{
	    os << "None";
	}
	return os;
    }
};

class MakeFiltgrps
{
    public:
    Filtgrps operator()(const Filtgrps& s) { return Filtgrps(s); }
    Filtgrps operator()(const int32& s) { return Filtgrps(s); }
    Filtgrps operator()(const char* s) { return Filtgrps(s); }
    Filtgrps operator()(const std::string& s) { return Filtgrps(s); }
};
#endif
