#ifndef PPSSUMMOMOSWMONG
#define PPSSUMMOMOSWMONG

#include "ppssumm_typedef.h"
#include <string>
#include <cctype>
#include <sstream>
#include <functional>
#include <iterator>
#include "Dal.h"
#include "errstr.h"

// A long time a go in a development cycle now long forgotten
// The OSW was monged so it would contain either the OSW ( digit 0-9)
// OR the ENG2/ENG4 mode filter (A-Z).
// For ppssumm output purposes we want to separate one from the other

struct OmOswRemoveFilter_ : unary_function< std::string , std::string > 
{
    // Cut a string at first '\0'
    public:
    OmOswRemoveFilter_ ( std::string f=" ") 
    : fill_(f)
    {}

    std::string operator()( const std::string& v_ ) const 
    {
    
        return (v_.find_first_of("0123456789") != v_.npos)
            ? v_
            : fill_
        ;
    }
    private:
    const string fill_;
};

struct OmOswRemoveOsw_ : unary_function< std::string , std::string > 
{
    // Cut a string at first '\0'
    public:
    OmOswRemoveOsw_ ( std::string f=" ") 
    : fill_(f)
    {}

    std::string operator()( const std::string& v_ ) const 
    {
    
        return (v_.find_first_of("01234567890") == v_.npos)
            ? v_
            : fill_
        ;
    }
    private:
    const string fill_;
};


#endif
