#ifndef PPSSUMMS_SIMPLEATTRIBUTE
#define PPSSUMMS_SIMPLEATTRIBUTE

#include <string>
#include <ostream>
#include "stripws.h"

#include "Dal.h"

class SAttribute 
{
    // Simple class to store what can be turned into an Attribute
    // Also usefull for storing split summary lines.
public:
    SAttribute( const std::string& n="" 
        , const std::string& v="" 
        , const std::string& c=""
    ) : name_(n) , value_(v) , comment_(c) {}
    
    std::string name() const { return name_;}
    SAttribute name(const std::string& n) 
    { name_ = n; return *this; }

    std::string value() const { return value_; }
    SAttribute& value(const std::string& v) 
    { value_ = v; return *this;}

    std::string comment() const { return comment_; }
    SAttribute  comment(const std::string& c)
    { comment_ = c ; return *this; }

    // strictly speeking an attribute name is at most 8 characters long
    std::string name8() const 
    { return (name_.length() > 8) ? name_.substr(0,8) : name_ ; }

    friend std::ostream &operator<<(std::ostream& os ,  const SAttribute& att)
    {
        os  << "Name/Value/Comment = " 
            << att.name_ << "/" << att.value_ << "/" << att.comment_ << std::endl;
        return os;
    }
private:
    std::string name_;
    std::string value_;
    std::string comment_;


};

#endif
